/*************************************************************
 * Explore the power of the Datagrid with TemplateColumns ! 
 * Use any control as column content !
 * Copyright Manuel Cavallaro 2003-2007 
 * The dytemplatecolumns.dll is freeware only for private use. 
 * comments: 
 * info@manuelcavallaro.com 
 * 
 * Please note, that the code in this file is only a hack to
 * demonstrate what you can do with the dll. Therefore 
 * some parts in this file are not well developed and not 
 * suitable for a real-world solution.
 * **********************************************************/

using System;
using System.Collections;
using System.Configuration;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using DynTemplateColumns.NCFDataGrid;


namespace GridMe
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		/// <summary>
		/// Path of xml containing data ... remember to grant write access
		/// </summary>
		private string m_strGridPath="";

		/// <summary>
		/// Path of xml containing data
		/// </summary>
		private string m_strInnerGridPath="";

		/// <summary>
		/// Path of xml containing data
		/// </summary>
		private string m_strTypesPath="";

		/// <summary>
		/// seems to be our DataGrid
		/// </summary>
		protected System.Web.UI.WebControls.DataGrid SuperGrid;

		/// <summary>
		/// DataSet for grid
		/// </summary>
		private DataSet m_dsGridData=null;

		/// <summary>
		/// DataSet for inner grid
		/// </summary>
		private DataSet m_dsInnerGridData=null;
		
		/// <summary>
		/// DataSet for type detail table(s)
		/// </summary>
		private DataSet m_dsDropDownData=null;

		/// <summary>
		/// DataSet for personal detail table(s)
		/// </summary>
		private int m_nVisibleInnerGrids=0;
		
		/// <summary>
		/// <c>SuperGrid_Init()-</c>
		/// initialisitaion of the DataGrid, don't forget in a real world solution to set up the css classes
		/// </summary>
		private void SuperGrid_Init()
		{

			SuperGrid.DataKeyField="id";

			#region IDColumn
			//ID
			BoundColumn	bc_ID= CFCustomColumn.CreateBoundColumn("id","id",true);
			SuperGrid.Columns.Add(bc_ID);
			#endregion

			#region BoundColumns
			//Name
			SuperGrid.Columns.Add(CFCustomColumn.CreateBoundColumn("author","name",false));
			//Vorname
			SuperGrid.Columns.Add(CFCustomColumn.CreateBoundColumn("age","age",false));	
			

			//just to see the appropriate id
			BoundColumn bc_tid=CFCustomColumn.CreateBoundColumn("type-id","type",true);
			bc_tid.Visible=false;
			SuperGrid.Columns.Add(bc_tid);	
			#endregion

			#region DropDownColumn
			TemplateColumn myCol=	CFCustomColumn.CreateTemplateColumn(
						(new Label()).GetType(),  /*yes i know, i'm lazy!*/
						new CFEventhandlers.CustomColumnItemDelegate(SuperGrid_CreateLabel),
						new CFEventhandlers.CustomColumnItemDelegate(SuperGrid_BindLabel),
						(new DropDownList()).GetType(),
						new CFEventhandlers.CustomColumnItemDelegate(SuperGrid_CreateDropDown),
						new CFEventhandlers.CustomColumnItemDelegate(SuperGrid_BindDropDown));
			
			myCol.HeaderText="type";
			SuperGrid.Columns.Add(myCol);
			#endregion
			
			
			#region EditColumn
			EditCommandColumn myEditCol	= new EditCommandColumn();
			myEditCol.ButtonType			= ButtonColumnType.LinkButton;

			myEditCol.UpdateText			= "<IMG SRC=images/Update.gif alt=update Border=0>";
			myEditCol.CancelText			= "<IMG SRC=images/Cancel.gif alt=cancel Border=0>";
			myEditCol.EditText			= "<IMG SRC=images/Edit.gif alt=edit Border=0 Width=12 Height=12>";
			
			myEditCol.ItemStyle.HorizontalAlign=HorizontalAlign.Center;
			SuperGrid.Columns.Add(myEditCol);
			#endregion

			//this column switches to detailview and back
			#region ButtonColumn
			ButtonColumn ShowDetail						= new ButtonColumn();
			ShowDetail.ButtonType						= ButtonColumnType.LinkButton;
			ShowDetail.Text								="<IMG SRC=images/Details.gif alt='View booklist' Border=0 Width=12 Height=12>";
			ShowDetail.CommandName						="ShowDetail";
			ShowDetail.ItemStyle.HorizontalAlign=HorizontalAlign.Center;
			SuperGrid.Columns.Add(ShowDetail);
			#endregion

			#region GridColumn
					
			//for easyness this grid is readonly, therefore no change between normal and edit view
			TemplateColumn myGridCol=	CFCustomColumn.CreateTemplateColumn(
				(new DataGrid()).GetType(),
				new CFEventhandlers.CustomColumnItemDelegate(SuperGrid_CreateInnerGrid),
				new CFEventhandlers.CustomColumnItemDelegate(SuperGrid_BindInnerGrid),
				(new DataGrid()).GetType(),
				new CFEventhandlers.CustomColumnItemDelegate(SuperGrid_CreateInnerGrid),
				new CFEventhandlers.CustomColumnItemDelegate(SuperGrid_BindInnerGrid));
			
			myGridCol.HeaderText="booklist";
			SuperGrid.Columns.Add(myGridCol);
			#endregion

			this.SuperGrid.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.SuperGrid_Update);
			this.SuperGrid.EditCommand	+= new System.Web.UI.WebControls.DataGridCommandEventHandler(this.SuperGrid_Edit);
			this.SuperGrid.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.SuperGrid_Cancel);
			this.SuperGrid.ItemCommand	+= new System.Web.UI.WebControls.DataGridCommandEventHandler(this.SuperGrid_Item);
			
			m_nVisibleInnerGrids=0;
			this.SuperGrid.PreRender += new EventHandler(SuperGrid_PreRender);
		}


		/// <summary>
		/// 
		/// </summary>
		protected void SuperGrid_Bind()
		{	
			SuperGrid_CreateDataSets();

			SuperGrid.DataSource=m_dsGridData.Tables[0];

			SuperGrid.DataBind();
		}


		/// <summary>
		/// 
		/// </summary>
		protected void SuperGrid_CreateDataSets()
		{		
			//-in a real solution you should put your data in cache and update only on changes ...
			//-multiple datasets might be overhead, but i love this readxml function ...
			if(m_dsDropDownData==null || m_dsGridData==null)
			{
				m_dsDropDownData=new DataSet();
				m_dsDropDownData.ReadXml(m_strTypesPath);

				m_dsGridData=new DataSet();
				m_dsGridData.ReadXml(m_strGridPath);
				
				m_dsInnerGridData=new DataSet();
				m_dsInnerGridData.ReadXml(m_strInnerGridPath);
			}
		}


		/// <summary>
		/// Binding of Data, don't forget in a real world solution to set up the css classes
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="args"></param>
		private void SuperGrid_BindLabel(object sender, CustomColumnItemEventArgs args)
		{
			//get index of sender
			int masterrowindex = GetItemIndex((Control)sender);
			if(masterrowindex< (int)0)
				return;

			//rename tables, easier to see which table contains foreign-id and which is target
			//this kind of work generally shouldn't be done here, but hey it's a sample
			DataTable masterTable = m_dsGridData.Tables[0];
			DataTable detailTable = m_dsDropDownData.Tables[0];

			//get foreign-id value in master datatable
			string strFID=GetTableValue("type",masterrowindex,masterTable).ToString();

			//loop rows in detail datatable
			for(int detailrowindex=0; detailrowindex < detailTable.Rows.Count; detailrowindex++)
			{
				//check if id is the searched foreign-id
				if(GetTableValue("id",detailrowindex,detailTable).ToString() == strFID)
				{
					//get name information and put it in the gridcell
					((Label)sender).Text = GetTableValue("name",detailrowindex,detailTable).ToString();
					return;
				}
			}
		}

		
		/// <summary>
		/// Binding of dropdowns, don't forget in a real world solution to set up the css classes
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="args"></param>	
		private void SuperGrid_BindDropDown(object sender, CustomColumnItemEventArgs args)
		{
			//if this fails something is going really bad for you
			DropDownList x= ((DropDownList)sender);
				
			int masterrowindex=GetItemIndex(x);
			if(masterrowindex < (int)0)
				return;

			//Tables
			DataTable detailTable = m_dsDropDownData.Tables[0];
			DataTable masterTable = m_dsGridData.Tables[0];

			//get foreign-id value in master datatable
			string strFID=GetTableValue("type",masterrowindex,masterTable).ToString();
			
			//get column index in type table
			int indexID=detailTable.Columns.IndexOf("id");
			int indexName=detailTable.Columns.IndexOf("name");

			//loop detailTable and populate the DropDown x
			for(int rowindex=0; rowindex < detailTable.Rows.Count; rowindex++)
			{
				ListItem li = new ListItem();
				li.Value= detailTable.Rows[rowindex].ItemArray.GetValue(indexID).ToString();
				li.Text=detailTable.Rows[rowindex].ItemArray.GetValue(indexName).ToString();
				x.Items.Add(li);

				//important!
				if(strFID == li.Value)
					x.SelectedIndex=rowindex;
			}
		}


		/// <summary>
		/// gets called from datagrid, when it creates the control
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="args"></param>
		private void SuperGrid_CreateDropDown(object sender, CustomColumnItemEventArgs args)
		{
			DropDownList x= ((DropDownList)sender);
	
			//you can change the control properties here e.g.
			x.EnableViewState = true;
		}


		/// <summary>
		/// gets called from datagrid, when it creates the control
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="args"></param>
		private void SuperGrid_CreateLabel(object sender, CustomColumnItemEventArgs args)
		{
			//you can change the control properties here
		}


		/// <summary>
		/// gets called from datagrid, when it creates the control
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="args"></param>
		private void SuperGrid_CreateInnerGrid(object sender, CustomColumnItemEventArgs args)
		{
			DataGrid grid=(DataGrid)sender;
			
			grid.Columns.Add(CFCustomColumn.CreateBoundColumn("id","id",true));
			grid.Columns.Add(CFCustomColumn.CreateBoundColumn("title","name",false));
			grid.Columns.Add(CFCustomColumn.CreateBoundColumn("publisher","house",false));				

			EditCommandColumn myEditCol	= new EditCommandColumn();
			myEditCol.ButtonType			= ButtonColumnType.LinkButton;

			myEditCol.UpdateText			= "<IMG SRC=images/Update.gif alt=update Border=0>";
			myEditCol.CancelText			= "<IMG SRC=images/Cancel.gif alt=cancel Border=0>";
			myEditCol.EditText			= "<IMG SRC=images/Edit.gif alt=edit Border=0 Width=12 Height=12>";
			
			myEditCol.ItemStyle.HorizontalAlign=HorizontalAlign.Center;
			grid.Columns.Add(myEditCol);

			grid.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.InnerGrid_Update);
			grid.EditCommand	+= new System.Web.UI.WebControls.DataGridCommandEventHandler(this.InnerGrid_Edit);
			grid.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.InnerGrid_Cancel);

			grid.EnableViewState=true;
			grid.AutoGenerateColumns=false;
		}


		/// <summary>
		/// gets called, when datagrid creates the Gridcolumn
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="args"></param>
		private void SuperGrid_BindInnerGrid(object sender, CustomColumnItemEventArgs args)
		{
			DataGrid grid=(DataGrid)sender;

			int itemIndex=GetItemIndex(grid);

			string itemID=GetTableValue("id",itemIndex,m_dsGridData.Tables[0]).ToString();
			
			object detailID=null;
			try
			{
				if((bool)ViewState["ShowDetail_Visible"+itemIndex.ToString()]==true)
					grid.Visible=true;
				else
				{
					grid.Visible=false;
					return;
				}

				detailID=ViewState["ShowDetail_ID"+itemIndex.ToString()];
				if(detailID==null)
					return;
				if(detailID.ToString()!=itemID)
					return;
			}
			catch(Exception ex)
			{
				grid.Visible=false;
				return;
			}
			try
			{
				grid.EditItemIndex=(int)ViewState["ShowDetail_Edit"+itemIndex];
			}
			catch(Exception ex2)
			{
				grid.EditItemIndex=-1;
			}

			m_nVisibleInnerGrids++;
			string strExpr="author = " + (ViewState["ShowDetail_ID"+itemIndex.ToString()]).ToString();
			string strSort = "id ASC";

			DataRow[] foundRows = m_dsInnerGridData.Tables[0].Select(strExpr,strSort);

			DataSet copy = m_dsInnerGridData.Clone();
				
			foreach(DataRow dr in foundRows)
			{
				copy.Tables[0].Rows.Add(dr.ItemArray);
			}

			grid.DataSource=copy.Tables[0];

			//well a css class would do it better ...
			grid.Width=Unit.Percentage(100.0);
			grid.Height=Unit.Percentage(100.0);
			grid.BorderWidth=Unit.Pixel(0);
			grid.HeaderStyle.BackColor=Color.Gold;
			grid.HeaderStyle.ForeColor=Color.Black;
			grid.HeaderStyle.Font.Size = FontUnit.Point(10);
			grid.Font.Name="Verdana";
			grid.Font.Size=FontUnit.Point(9);
			grid.ItemStyle.BackColor=Color.White;
		}


		/// <summary>
		/// gets called when user clicks on edit
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		public void SuperGrid_Edit(Object sender, DataGridCommandEventArgs e) 
		{
			SuperGrid.EditItemIndex = (int)e.Item.ItemIndex;

			SuperGrid_Bind();
		}


		/// <summary>
		/// Update and write changes.
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		public void SuperGrid_Update(Object sender, DataGridCommandEventArgs e) 
		{

			//security for the sample
			if(e.Item.Cells[0].Text.Length > 50 ||
				((TextBox)e.Item.Cells[1].Controls[0]).Text.Length > 50 ||
				((TextBox)e.Item.Cells[2].Controls[0]).Text.Length > 50)
				return;

			//get values, using fixed numbers here is ok, since you provide the column order yoursef in the SuperGrid_Init function
			string UpdateID		= e.Item.Cells[0].Text;
			string UpdateName  = ((TextBox)e.Item.Cells[1].Controls[0]).Text;
			string UpdateAge  = ((TextBox)e.Item.Cells[2].Controls[0]).Text.Trim();
			string UpdateTypeID = ((DropDownList)e.Item.Cells[4].Controls[0]).SelectedItem.Value; 
			
			//create sets
			SuperGrid_CreateDataSets();

			//update xml ...
			for(int rowindex=0; rowindex < m_dsGridData.Tables[0].Rows.Count; rowindex++)
			{
				if(UpdateID==m_dsGridData.Tables[0].Rows[rowindex].ItemArray.GetValue(0).ToString())
				{
					m_dsGridData.Tables[0].Rows[rowindex].ItemArray=new Object[]{UpdateID,UpdateName,UpdateAge,UpdateTypeID};
					m_dsGridData.AcceptChanges();
					m_dsGridData.WriteXml(m_strGridPath); 
					break;
				}
			}
			
			//end  edit mode
			SuperGrid_Cancel(sender,e);	
		}


		/// <summary>
		/// <c>SuperGrid_Cancel()-</c>
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		public void SuperGrid_Cancel(Object sender, DataGridCommandEventArgs e) 
		{
			SuperGrid.EditItemIndex = -1;
			SuperGrid_Bind();
		}


		/// <summary>
		/// gets called on ItemCommands
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		public void SuperGrid_Item(Object sender, DataGridCommandEventArgs e)
		{
			if(e.CommandName == "ShowDetail")
			{
				//switch visibility of gridcolumn
				bool bShow=true;
				string strIndex=e.Item.ItemIndex.ToString();

				try
				{
					bShow=(bool)ViewState["ShowDetail_Visible"+strIndex]? false : true;
				}
				catch(Exception ex)
				{
					ViewState.Add("ShowDetail_Visible"+strIndex,(object)true);
				}
	
				SuperGrid_CreateDataSets();

				ViewState.Add("ShowDetail_ID"+strIndex,GetTableValue("id",e.Item.ItemIndex,m_dsGridData.Tables[0]));

				ViewState["ShowDetail_Visible"+strIndex]=(object)bShow;

				SuperGrid_Bind();
			}
		}


		/// <summary>
		/// gets called when user clicks on edit
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		public void InnerGrid_Edit(Object sender, DataGridCommandEventArgs e) 
		{
			m_nVisibleInnerGrids++;
			int itemIndex=GetItemIndex((Control)sender);

			ViewState.Add("ShowDetail_Edit"+itemIndex,(object)e.Item.ItemIndex);
			SuperGrid_Bind();
		}
		

		/// <summary>
		/// Update and write changes.
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		public void InnerGrid_Update(Object sender, DataGridCommandEventArgs e) 
		{

			m_nVisibleInnerGrids++;

			if(e.Item.Cells[0].Text.Length > 50 ||
				((TextBox)e.Item.Cells[1].Controls[0]).Text.Length > 50 ||
				((TextBox)e.Item.Cells[2].Controls[0]).Text.Length > 50)
				return;
			
			//get values, using fixed numbers here is ok, since you provide the column order yoursef in the SuperGrid_Init function
			string UpdateID		= e.Item.Cells[0].Text;
			string UpdateTitle  = ((TextBox)e.Item.Cells[1].Controls[0]).Text;
			string UpdatePublisher  = ((TextBox)e.Item.Cells[2].Controls[0]).Text.Trim();
						
			//create sets
			SuperGrid_CreateDataSets();
			int x=GetItemIndex((Control)sender);

			string UpdateAuthor=GetTableValue("id",x,m_dsGridData.Tables[0]).ToString();
			
				//update xml ...
			for(int rowindex=0; rowindex < m_dsInnerGridData.Tables[0].Rows.Count; rowindex++)
			{
				if(UpdateID==m_dsInnerGridData.Tables[0].Rows[rowindex].ItemArray.GetValue(0).ToString())
				{
					m_dsInnerGridData.Tables[0].Rows[rowindex].ItemArray=new Object[]{UpdateID,UpdateAuthor,UpdateTitle,UpdatePublisher};
					m_dsInnerGridData.AcceptChanges();
					m_dsInnerGridData.WriteXml(m_strInnerGridPath); 
					break;
				}
			}
			
			//end  edit
			InnerGrid_Cancel(sender,e);
		}


		/// <summary>
		/// <c>SuperGrid_Cancel()-</c>
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		public void InnerGrid_Cancel(Object sender, DataGridCommandEventArgs e) 
		{
			m_nVisibleInnerGrids++;
			int itemIndex=GetItemIndex((Control)sender);

			ViewState.Add("ShowDetail_Edit"+itemIndex,(object)(-1));
			SuperGrid_Bind();
		}


		#region Web Form Designer generated code
		
		/// <summary>
		/// 
		/// </summary>
		/// <param name="e"></param>
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();

			m_strGridPath=ConfigurationSettings.AppSettings["authors"];
			m_strTypesPath=ConfigurationSettings.AppSettings["types"];
			m_strInnerGridPath=ConfigurationSettings.AppSettings["books"];
			
			SuperGrid_Init();

			if(!IsPostBack)
				SuperGrid_Bind();

			base.OnInit(e);
		}


		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
	
		
		#endregion
		
		/// <summary>
		/// <c>GetTableValue()-</c>
		/// Get value by columnname and rowindex in a DataTable.
		/// </summary>
		/// <param name="columnName">column name</param>
		/// <param name="rowindex">row index</param>
		/// <param name="dt">the data table</param>
		/// <returns>the object in the cell</returns>
		static protected object GetTableValue(string columnName, int rowindex, DataTable dt)
		{
			try
			{
				int indexOfColumn=dt.Columns.IndexOf(columnName);
			
				return dt.Rows[rowindex].ItemArray.GetValue(indexOfColumn);
			}
			catch(Exception e)
			{
				return null;
			}
		}


		/// <summary>
		/// <c>GetItemIndex()-</c>
		/// check datasets and get itemindex
		/// </summary>
		/// <returns>index of item</returns>
		/// <param name="ctrlSender">the itemtemplate control (event sender !)</param>
		private int GetItemIndex(Control ctrlSender)
		{
			try
			{
				//get container
				DataGridItem container=(DataGridItem)(ctrlSender).NamingContainer;

				//calculate row in dataset
				return container.ItemIndex; //+ SuperGrid.TabIndex * SuperGrid.PageSize;
			}
			catch(Exception e)
			{
				return -1;
			}
		}

	
		/// <summary>
		/// 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void SuperGrid_PreRender(object sender, System.EventArgs e)
		{
			if(m_nVisibleInnerGrids==0)
				 SuperGrid.Columns[SuperGrid.Columns.Count-1].Visible=false;
			else
				SuperGrid.Columns[SuperGrid.Columns.Count-1].Visible=true;
		}
	}
}